from microbit import *
import random
import radio

radio.config(group=1)
radio.on()

data2 = 0
data3 = 0
display.clear()
NO_SMALL = Image(
            "00000:"
            "09090:"
            "00900:"
            "09090:"
            "00000")

def set_data():
    data = 0
    for i in range(4):
        data = data + random.randint(0, 1)
        data = data << 1
    return data

def set_parity(n):
    c = 0
    m = n
    for i in range(5):
        if m % 2 == 1:
            c = c + 1
        m = m >> 1
    if c % 2 == 0:
        n = n + 1
    return n

def check_parity(n):
    m = n
    d = 0
    for i in range(5):
        if m % 2 == 1:
            d = d + 1
        m = m >> 1
    if d % 2 != 0:
        return True
    else:
        return False

def Rev(x, c):
    a = 1
    a = a << (c - 1)
    if a & x == 0:
        return a | x
    else:
        return (a ^ 31) & x

def Plotx(k, n):
    for i in range(4, -1, -1):
        if n % 2 == 1:
            display.set_pixel(i, k, 9)
        n = n >> 1

while True:
    if button_a.was_pressed():
        display.clear()
        data2 = set_data()
        x = set_parity(data2)
        Plotx(0, x)
        radio.send(str(x))
    if button_b.was_pressed():
        display.clear()
        data3 = set_data()
        y = set_parity(data3)
        y = Rev(y, random.randint(1, 4))
        Plotx(0, y)
        radio.send(str(y))
    b = radio.receive()
    if b != None:
        n = int(b)
        if n >= 0:
            if check_parity(n):
                display.clear()
                display.show(Image.DIAMOND_SMALL)
                Plotx(4, n)
                sleep(1000)
                radio.send(str(-1))
            else:
                display.show(NO_SMALL)
                Plotx(4, n)
                sleep(1000)
                radio.send(str(-100))
        elif n < -1:
            display.clear()
            z = set_parity(data3)
            Plotx(0, z)
            sleep(1000)
            radio.send(str(z))